function CIR = compute_CIR(A,vx,x_grid,B,vx0,Mx,SS)

% Index for optimal reset capital
            
[~,ind_ast]    =min(abs(x_grid-SS.x_ast));
            
f         = (B./(x_grid(2)-x_grid(1)))*(vx-Mx.*vx0);
f(1)      = 0;
f(end)    = 0;
     
v_0       = A\f;

% Apply Lagrange Interpolation for v_0(x_hat_ast) in the grid

x_1       = x_grid(ind_ast-1);
x_2       = x_grid(ind_ast);
x_3       = x_grid(ind_ast+1);

fx_1      = v_0(ind_ast-1);
fx_2      = v_0(ind_ast);
fx_3      = v_0(ind_ast+1);

v_0_ast   = (SS.x_ast-x_2)*(SS.x_ast-x_3)/(x_1-x_2)/(x_1-x_3)*fx_1+...
            (SS.x_ast-x_1)*(SS.x_ast-x_3)/(x_2-x_1)/(x_2-x_3)*fx_2+...
            (SS.x_ast-x_1)*(SS.x_ast-x_2)/(x_3-x_1)/(x_3-x_2)*fx_3;
                 
CIR       = v_0_ast/SS.Etau;
            
return